/* Header file for Final_Project.c */

// bit handling macros for i/o registers
#define READ(U, N) ((U) >> (N) & 1u)
#define SET(U, N) ((void)((U) |= 1u << (N)))
#define CLR(U, N) ((void)((U) &= ~(1u << (N))))
#define FLIP(U, N) ((void)((U) ^= 1u << (N)))

// task subroutines
unsigned int read_ADC(void);
void read_accel(void);  	 
void read_force(void);

unsigned int read_A1(void);
unsigned int read_A2(void);
unsigned int read_F1(void);
unsigned int read_F2(void);
unsigned int read_F3(void);
unsigned int read_G1(void);
unsigned int read_G2(void);


static inline void delay_us(unsigned int microseconds) __attribute__((always_inline));
void delay_us(unsigned int microseconds)
{
    __asm__ volatile (
        "1: push r22"     "\n\t"
        "   ldi  r22, 4"  "\n\t"
        "2: dec  r22"     "\n\t"
        "   brne 2b"      "\n\t"
        "   pop  r22"     "\n\t"
        "   sbiw %0, 1"   "\n\t"
        "   brne 1b"
        : "=w" ( microseconds )
        : "0" ( microseconds )
    );
}
